#include "COledScreen.h"

/*****************************************************************************
 * Function    : begin                                                          *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
COledScreen::COledScreen()
{
    u8x8 = new U8X8_SSD1306_128X64_NONAME_HW_I2C(9);
    u8x8->begin();
    u8x8->setPowerSave(0);
    u8x8->setFont(u8x8_font_chroma48medium8_r);

    for(int i=0;i<10; i++)
    {
      u8Buffer[i] = 0;
    }    
}

/*****************************************************************************
 * Function    : setBackground                                                  *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setBackground(uint8_t red, uint8_t green, uint8_t blue)
{
    //background(red*255/100,green*255/100,blue*255/100);
}

/*****************************************************************************
 * Function    : setFill                                                        *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setFill(uint16 color)
{
    //u16FillColor = color;
}

/*****************************************************************************
 * Function    : setFill                                                        *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setColor(uint16 color)
{
    //u16Color = color;
    //display->setTextColor(u16Color);
}

/*****************************************************************************
 * Function    : setStroke                                                      *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setStroke(uint8_t red, uint8_t green, uint8_t blue)
{
    //stroke(red*255/100,green*255/100,blue*255/100);
}

/*****************************************************************************
 * Function  : effacerEcran                                                  *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::clearDisplay(void)
{
  //display->clearDisplay();
  u8x8->clearDisplay();
}

/*****************************************************************************
 * Function  : effacerEcran                                                  *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::launchDisplay(void)
{
  //display->display();
}

/*****************************************************************************
 * Function  : text                                                           *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setPoint(int16_t x, int16_t y)
{
  //display->drawPixel(x,y,u16Color);
}

/*****************************************************************************
 * Function  : text                                                           *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::drawLine(int16_t x0, int16_t y0, int16_t x1, int16_t y1)
{
  //display->drawLine(x0,y0,x1,y1,u16Color);
}

/*****************************************************************************
 * Function  : setTextSize                                                    *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setFont(int font)
{
    if(font == 1)
    {
        u8x8->setFont(u8x8_font_open_iconic_arrow_1x1);
    }
    else
    {
        u8x8->setFont(u8x8_font_chroma48medium8_r);
    }
}

/*****************************************************************************
 * Function    : setTextSize                                                    *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setTextSize(int size)
{
  /*int newSize;
  
  if(size < 1) newSize = 1;
  else if (size > 3) newSize = 2;
  else newSize = size;
  
  display->setTextSize(newSize);*/
}

/*****************************************************************************
 * Function    : text                                                           *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setText(double val, int16_t x, int16_t y)
{
    String strText = String(int32(val));  
    
    /*display->setCursor(x,y);
    display->print(strText);*/
    
    u8x8->drawString(x,y,strText.c_str());
}

/*****************************************************************************
 * Function    : text                                                           *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setText(const char * val, int16_t x, int16_t y)
{
    /*display->setCursor(x,y);
    
    display->print(val);*/
    
    u8x8->drawString(x,y,val);
}

/*****************************************************************************
 * Function    : text                                                           *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setText(String strText, int16_t x, int16_t y)
{
    /*display->setCursor(x,y);
    
    display->print(strText);*/
    u8x8->drawString(x,y,strText.c_str());
}


/*****************************************************************************
 * Function  : text                                                           *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setInverseFont(bool bInv)
{
    /*display->setCursor(x,y);
    
    display->print(strText);*/
    u8x8->setInverseFont(bInv);
}

/*****************************************************************************
 * Function    : text                                                           *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::circle(int16_t x,int16_t y,int16_t rayon)
{
    /*if(u16FillColor == u16Color)
    {
    display->fillCircle(x,y,rayon,u16FillColor); 
    }
    else
    {
    display->drawCircle(x,y,rayon,u16Color);
    }*/
}

/*****************************************************************************
 * Function    : text                                                           *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::rect(int16_t x,int16_t y,int16_t longu, int16_t larg)
{
    /*if(u16FillColor == u16Color)
    {
    display->fillRect(x,y,longu,larg,u16FillColor);
    }
    else
    {
    display->drawRect(x,y,longu,larg,u16Color);
    }*/
}

/*****************************************************************************
 * Function    : text                                                           *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::triangle(int16_t x0, int16_t y0, int16_t x1, int16_t y1, int16_t x2, int16_t y2)
{
    /*if(u16FillColor == u16Color)
    {
    display->fillTriangle(x0,y0,x1,y1,x2,y2,u16FillColor); 
    }
    else
    {
    display->drawTriangle(x0,y0,x1,y1,x2,y2,u16Color);
    }*/
}

void COledScreen::drawTile(uint8_t x, uint8_t y, uint8_t cnt, uint8_t *tile_ptr)
{
    u8x8->drawTile( x,  y, cnt,tile_ptr);
}

/*****************************************************************************
 * Function    : setData                                                     *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::setData (uint8_t id, uint8_t data)
{
  u8Buffer[id] = data;
}

/*****************************************************************************
 * Function    : getBuffer                                                   *
 *...........................................................................*
 * Description :                                                             *
 *****************************************************************************/
void COledScreen::getBuffer(uint8_t* buffer)
{
    for(int i=0;i<10; i++)
    {
      buffer[i] = u8Buffer[i];
    } 
}
    
